unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    PaintBox1: TPaintBox;
    SpeedButton1: TSpeedButton;
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
  private
    procedure Inic_Estrela(Sender: TObject);
    { Private declarations }
  public
    { Public declarations }
    procedure Inic_Nave(Sender:TObject);
    procedure Inic_Bala(Sender:TObject);
    procedure Inic_Enemy(Sender:TObject);
  end;

type
  TNave = object
    N_Cima  : Boolean;
    N_Baixo : Boolean;
    N_Esquerda : Boolean;
    N_Direita  : Boolean;
    N_Sprite   : TImage;
    N_Tempo    : TTimer;
    N_Atirou   : Boolean;
    N_Velocidade : Integer;
end;

type
  TBala = object
    B_Sprite     : TShape;
    B_Velocidade : Integer;
    B_Tempo      : TTimer;
    B_Cima       : Boolean;
    B_Left       : Integer;
    B_Top        : Integer;
end;

type
  TEstrela = object
    Left  : Integer;
    Top   : Integer;
    Tempo : TTimer;
    procedure Criar;
end;

type
  TEnemy = object
    E_Life : Integer;
    E_Velocidade : Integer;
    E_Sprite : TImage;
    E_Tempo : TTimer;
end;

const N = 100;
      S = '.';
      V = 5;
var
  Form1: TForm1;
  Estrela : array[1..N] of TEstrela;
  Star : TEstrela;
  Nave   : TNave;
  Bala   : TBala;
  N_Bala : Integer;
  Enemy  : TEnemy;

implementation

{$R *.DFM}

procedure TEstrela.Criar;
var i : Integer;
begin
  for i:= 1 to N do
      with Form1 do
      begin
        Estrela[i].Left := Random(ClientWidth);
        Estrela[i].Top  := Random(ClientHeight) * -1;
        if N > N div 2 then
           Canvas.Font.Color := clWhite
        else
           Canvas.Font.Color := clSilver;
        Canvas.Font.Size :=20;
        Canvas.TextOut(Estrela[i].Left,Estrela[i].Top,S);
      end;
end;

procedure TForm1.Inic_Estrela(Sender:TObject);
var i : Integer;
begin
  for i:= 1 to N do
      with Estrela[i] do
           begin
             if (Top < ClientHeight) then
                begin
                  //Estrela[i].Left := Random(ClientWidth);
                  Top  := Top  + V;
                  Canvas.TextOut(Left,Top,S);
                end
             else
                begin
                  Randomize;
                  Estrela[i].Top  := Random(ClientHeight) * -1;
                  Estrela[i].Left := Random(ClientWidth);
                end;
           end;
end;


procedure TForm1.Inic_Bala(Sender:TObject);
begin
  if Bala.B_Cima then
     with Bala do
        begin
          B_Sprite.Top := B_Sprite.Top - B_Velocidade;
          if B_Sprite.Top + B_Sprite.Height <= 0 then
             begin
               Bala.B_Cima := False;
               Bala.B_Sprite.Free;
               Bala.B_Tempo.Free;
               Repaint;
             end;
        end;
end;

procedure TForm1.Inic_Nave(Sender:TObject);
var panel10,panel11 : integer;
    p10,p11 : Integer;
begin
  with Nave do
       begin
         N_Sprite.BringToFront;
         N_Sprite.Repaint;
         if N_Sprite.Left <= 0 then
            N_Sprite.Left := 0;
         if (N_Sprite.Left + N_Sprite.Width) >= Form1.ClientWidth then
            N_Sprite.Left := Form1.ClientWidth - N_Sprite.Width;
         if N_Sprite.Top <= 0 then
            N_Sprite.Top := 0;
         if (N_Sprite.Top + N_Sprite.Height) >= Form1.ClientHeight then
            N_Sprite.Top := Form1.ClientHeight - N_Sprite.Height;
         if N_Cima then
            N_Sprite.Top := N_Sprite.Top - N_Velocidade;
         if N_Baixo then
            N_Sprite.Top := N_Sprite.Top + N_Velocidade;
         if N_Direita then
            N_Sprite.Left := N_Sprite.Left + N_Velocidade + 2;
         if N_Esquerda then
            N_Sprite.Left := N_Sprite.Left - N_Velocidade - 2;
       end;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  with Enemy do
       begin

       end;

  with Star do
       begin
         Criar;
         Tempo := TTimer.Create(Self);
         Tempo.Interval := 1;
         Tempo.OnTimer  := Inic_Estrela;
       end;

  with Nave do
       begin
         N_Sprite := TImage.Create(Self);
         N_Sprite.Picture.LoadFromFile('Nave2.bmp');
         N_Sprite.Parent := Self;
         N_Sprite.Transparent := True;
         N_Sprite.Top  := Form1.ClientHeight div 2;
         N_Sprite.Left := 0;//Form1.ClientWidth div 2;
         N_Sprite.AutoSize := True;
         N_Sprite.Visible := True;

         N_Tempo := TTimer.Create(Self);
         N_Tempo.Interval := 1;
         N_Tempo.OnTimer := Inic_Nave;

         N_Cima     := False;
         N_Baixo    := False;
         N_Esquerda := False;
         N_Direita  := False;
         N_Atirou   := False;
         N_Velocidade := 1;
       end;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = vk_right then
     Nave.N_Direita := True;
  if Key = vk_left then
     Nave.N_Esquerda := True;
  if Key = vk_up then
     Nave.N_Cima := True;
  if Key = vk_down then
     Nave.N_Baixo := True;
  if (Key = vk_space) and (not Bala.B_Cima) then
     begin
       Canvas.Font.Color := clWhite;
       Canvas.TextOut(Random(ClientWidth),Random(ClientHeight),'POW');
       Bala.B_Sprite := TShape.Create(Self);
       Bala.B_Sprite.Parent := Self;
       Bala.B_Sprite.Width  := 5;
       Bala.B_Sprite.Height := 5;
       Bala.B_Sprite.Brush.Color := clYellow;

       Bala.B_Cima := True;
       Bala.B_Left := Nave.N_Sprite.Left + (Nave.N_Sprite.Width div 2);
       Bala.B_Top  := Nave.N_Sprite.Top;

       Bala.B_Sprite.Left := Bala.B_Left;
       Bala.B_Sprite.Top  := Bala.B_Top;

       Bala.B_Tempo := TTimer.Create(Self);
       Bala.B_Tempo.Interval := 1;
       Bala.B_Tempo.OnTimer := Inic_Bala;
       Bala.B_Velocidade := 8;

       inc(N_Bala);
       if N_Bala = 50 then
          N_Bala := 1;
     end;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  with Nave do
       begin
         if Key in [37..40] then
            begin
              N_Cima     := False;
              N_Baixo    := False;
              N_Direita  := False;
              N_Esquerda := False;
            end;
       end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  N_Bala := 1;
end;

procedure TForm1.Inic_Enemy(Sender: TObject);
begin

end;

end.
